import {TreeViewComponent} from "@syncfusion/ej2-angular-navigations"
import {MaskedTextBoxComponent} from "@syncfusion/ej2-angular-inputs"
import { Component, Inject, ViewChild } from '@angular/core';
import { DataManager, Query, ReturnOption, Predicate } from '@syncfusion/ej2-data';
/**
 * Default TreeView Component
 */
@Component({
    selector: 'control-content',
    templateUrl: 'default.html'
})
export class DefaultTreeViewComponent {

@ViewChild("treeviewObj") listTreeObj:TreeViewComponent;

@ViewChild("maskObj") maskObj:MaskedTextBoxComponent;
public checkNodes = [];
   // Hierarchical data source for TreeView component
   public localData: Object[] = [
  { id: 1,  name: "Australia", hasChild: true },
  { id: 2, pid: 1, name: "New South Wales" },
  { id: 3, pid: 1, name: "Victoria" },
  { id: 4, pid: 1, name: "South Australia" },
  { id: 6, pid: 1, name: "Western Australia" },
  { id: 7, pid: 1, name: "Brazil", hasChild: true },
  { id: 8, pid: 7, name: "Paraná" },
  { id: 9, pid: 7, name: "Ceará" },
  { id: 10, pid: 7, name: "Acre" },  
  { id: 21, name: "India", hasChild: true },
  { id: 22, pid: 21, name: "Assam" },
  { id: 23, pid: 21, name: "Bihar" },
  { id: 24, pid: 21, name: "Tamil Nadu" },
  { id: 25, pid: 21, name: "Punjab" }
];

    // Mapping TreeView fields property with data source properties
    public field:Object = { dataSource: this.localData, id: 'id', parentID: 'pid', text: 'name', hasChildren: 'hasChild', expanded: "expanded" }

   //Change the dataSource for TreeView
 changeDataSource(data) {
  for(let i=0; i < data.length;i++){
    let dataId = data[i]["id"].toString();
    if(this.listTreeObj.checkedNodes.indexOf(dataId) !== -1 && this.checkNodes.indexOf(dataId)===-1)
    this.checkNodes.push(dataId)
  }
  this.listTreeObj.fields = {
    dataSource: data, id: 'id', text: 'name',
    parentID: 'pid', hasChildren: 'hasChild'
  }
  
}

//Filtering the TreeNodes
 searchNodes(args) {
  let _text = this.maskObj.element.value;
  let predicats = [], _array = [], _filter = [];
  if (_text == "") {
    this.changeDataSource(this.localData);
  }
  else {
    let predicate = new Predicate('name', 'contains', _text, true);
    let filteredList = new DataManager(this.localData).executeLocal(new Query().where(predicate));
    for (var j = 0; j < filteredList.length; j++) {
      _filter.push(filteredList[j]["id"]);
      var filters = this.getFilterItems(filteredList[j], this.localData);
      for (var i = 0; i < filters.length; i++) {
        if (_array.indexOf(filters[i]) == -1 && filters[i] != null) {
          _array.push(filters[i]);
          predicats.push(new Predicate('id', 'equal', filters[i], false));
        }
      }
    }
    if (predicats.length == 0) {
      this.changeDataSource([]);
    } else {
      let query = new Query().where(Predicate.or(predicats));
      let newList = new DataManager(this.localData).executeLocal(query);
     this.changeDataSource(newList);
     var proxy = this;
      setTimeout(function (this) {
        proxy.listTreeObj.expandAll();
      }, 100);
    }
  }
}
dataBounded(args){
   this.listTreeObj.checkAll(this.checkNodes);
   console.log(this.checkNodes);
}
//Find the Parent Nodes for corresponding childs
 getFilterItems(fList, list) {
  let nodes = [];
  nodes.push(fList["id"]);
  let query2 = new Query().where('id', 'equal', fList["pid"], false);
  let fList1 = new  DataManager(list).executeLocal(query2);
  if (fList1.length != 0) {
    let pNode = this.getFilterItems(fList1[0], list);
    for (var i = 0; i < pNode.length; i++) {
      if (nodes.indexOf(pNode[i]) == -1 && pNode[i] != null)
        nodes.push(pNode[i]);
    }
    return nodes;
  }
  return nodes;
}

nodeCheck(args){
  if(args.action =="uncheck"){
    let id=args.data[0]["id"];
    this.checkNodes.splice(this.checkNodes.indexOf(id));
  }
}

}